unit uModifyDept;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, ClientDM,
  Vcl.Mask, Vcl.DBCtrls, StdCtrls, Controls, Classes, ExtCtrls;

type
  TfModifyDept = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    btOK: TButton;
    btCancel: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edDeptno: TEdit;
    edDName: TEdit;
    edLoc: TEdit;
  private
    { Private declarations }
    function GetDeptno: integer;
    procedure SetDeptno(Value: integer);
    function GetDName: string;
    procedure SetDName(Value: string);
    function GetLoc: string;
    procedure SetLoc(Value: string);
  public
    { Public declarations }
    property Deptno: integer read GetDeptno write SetDeptno;
    property DName: string read GetDName write SetDName;
    property Loc: string read GetLoc write SetLoc;
  end;

implementation

{$R *.dfm}

function TfModifyDept.GetDeptno: integer;
begin
  Result := -1;
  if edDeptno.Text <> '' then
    Result := StrToInt(edDeptno.Text);
end;

function TfModifyDept.GetDName: string;
begin
  Result := edDName.Text;
end;

function TfModifyDept.GetLoc: string;
begin
  Result := edLoc.Text;
end;

procedure TfModifyDept.SetDeptno(Value: integer);
var
  dn: Integer;
begin
  if not TryStrToInt(edDeptno.Text, dn) then edDeptno.Text := '0';

  if Value <> StrToInt(edDeptno.Text) then
  begin
    if Value <> -1 then
    begin
      edDeptno.Text := IntToStr(Value);
      edDeptno.ReadOnly := true;
    end;
  end;
end;

procedure TfModifyDept.SetDName(Value: string);
begin
  if Value <> edDName.Text then
  begin
    edDName.Text := Value;
  end;
end;

procedure TfModifyDept.SetLoc(Value: string);
begin
  if Value <> edLoc.Text then
  begin
    edLoc.Text := Value;
  end;
end;

end.
